/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
)

// checks if the DataSourceDescriptorProperty type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &DataSourceDescriptorProperty{}

// DataSourceDescriptorProperty struct for DataSourceDescriptorProperty
type DataSourceDescriptorProperty struct {
	JsonPath string `json:"json_path"`
	Description *string `json:"description,omitempty"`
	Group *string `json:"group,omitempty"`
	DataType DataType `json:"data_type"`
}

// NewDataSourceDescriptorProperty instantiates a new DataSourceDescriptorProperty object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewDataSourceDescriptorProperty(jsonPath string, dataType DataType) *DataSourceDescriptorProperty {
	this := DataSourceDescriptorProperty{}
	this.JsonPath = jsonPath
	this.DataType = dataType
	return &this
}

// NewDataSourceDescriptorPropertyWithDefaults instantiates a new DataSourceDescriptorProperty object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewDataSourceDescriptorPropertyWithDefaults() *DataSourceDescriptorProperty {
	this := DataSourceDescriptorProperty{}
	return &this
}

// GetJsonPath returns the JsonPath field value
func (o *DataSourceDescriptorProperty) GetJsonPath() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.JsonPath
}

// GetJsonPathOk returns a tuple with the JsonPath field value
// and a boolean to check if the value has been set.
func (o *DataSourceDescriptorProperty) GetJsonPathOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.JsonPath, true
}

// SetJsonPath sets field value
func (o *DataSourceDescriptorProperty) SetJsonPath(v string) {
	o.JsonPath = v
}

// GetDescription returns the Description field value if set, zero value otherwise.
func (o *DataSourceDescriptorProperty) GetDescription() string {
	if o == nil || IsNil(o.Description) {
		var ret string
		return ret
	}
	return *o.Description
}

// GetDescriptionOk returns a tuple with the Description field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *DataSourceDescriptorProperty) GetDescriptionOk() (*string, bool) {
	if o == nil || IsNil(o.Description) {
		return nil, false
	}
	return o.Description, true
}

// HasDescription returns a boolean if a field has been set.
func (o *DataSourceDescriptorProperty) HasDescription() bool {
	if o != nil && !IsNil(o.Description) {
		return true
	}

	return false
}

// SetDescription gets a reference to the given string and assigns it to the Description field.
func (o *DataSourceDescriptorProperty) SetDescription(v string) {
	o.Description = &v
}

// GetGroup returns the Group field value if set, zero value otherwise.
func (o *DataSourceDescriptorProperty) GetGroup() string {
	if o == nil || IsNil(o.Group) {
		var ret string
		return ret
	}
	return *o.Group
}

// GetGroupOk returns a tuple with the Group field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *DataSourceDescriptorProperty) GetGroupOk() (*string, bool) {
	if o == nil || IsNil(o.Group) {
		return nil, false
	}
	return o.Group, true
}

// HasGroup returns a boolean if a field has been set.
func (o *DataSourceDescriptorProperty) HasGroup() bool {
	if o != nil && !IsNil(o.Group) {
		return true
	}

	return false
}

// SetGroup gets a reference to the given string and assigns it to the Group field.
func (o *DataSourceDescriptorProperty) SetGroup(v string) {
	o.Group = &v
}

// GetDataType returns the DataType field value
func (o *DataSourceDescriptorProperty) GetDataType() DataType {
	if o == nil {
		var ret DataType
		return ret
	}

	return o.DataType
}

// GetDataTypeOk returns a tuple with the DataType field value
// and a boolean to check if the value has been set.
func (o *DataSourceDescriptorProperty) GetDataTypeOk() (*DataType, bool) {
	if o == nil {
		return nil, false
	}
	return &o.DataType, true
}

// SetDataType sets field value
func (o *DataSourceDescriptorProperty) SetDataType(v DataType) {
	o.DataType = v
}

func (o DataSourceDescriptorProperty) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o DataSourceDescriptorProperty) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["json_path"] = o.JsonPath
	if !IsNil(o.Description) {
		toSerialize["description"] = o.Description
	}
	if !IsNil(o.Group) {
		toSerialize["group"] = o.Group
	}
	toSerialize["data_type"] = o.DataType
	return toSerialize, nil
}

type NullableDataSourceDescriptorProperty struct {
	value *DataSourceDescriptorProperty
	isSet bool
}

func (v NullableDataSourceDescriptorProperty) Get() *DataSourceDescriptorProperty {
	return v.value
}

func (v *NullableDataSourceDescriptorProperty) Set(val *DataSourceDescriptorProperty) {
	v.value = val
	v.isSet = true
}

func (v NullableDataSourceDescriptorProperty) IsSet() bool {
	return v.isSet
}

func (v *NullableDataSourceDescriptorProperty) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableDataSourceDescriptorProperty(val *DataSourceDescriptorProperty) *NullableDataSourceDescriptorProperty {
	return &NullableDataSourceDescriptorProperty{value: val, isSet: true}
}

func (v NullableDataSourceDescriptorProperty) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableDataSourceDescriptorProperty) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


